



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>单链表创建、删除、查找、插入之C语言实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">单链表创建、删除、查找、插入之C语言实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 22:22:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文将详细的介绍C语言单链表的创建、删除、查找、插入以及输出功能</p>
<p>一、创建</p>
<div>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;stdlib.h&gt;

typedef int ElemType;<br />
/*结构体部分*/<br />
typedef struct Node<br />
{<br />
    ElemType data;   //数值域<br />
    struct Node *next;  //指针域<br />
}Linklist;

Linklist *InitList(Linklist *L)    //初始化单链表<br />
{<br />
    L = (Linklist *) malloc(sizeof(Linklist));<br />
    L-&gt;next = NULL;<br />
    return L;<br />
}

Linklist *CreateList(int n)<br />
{<br />
    /*通过输入n个数据，创建一个单链表*/<br />
    int x,i;<br />
    Linklist *L,*r,*p;<br />
    L = InitList(L); //构造头结点<br />
    r = L;<br />
    printf("input %d value: ",n);<br />
    for(i=;i&lt;n;i++)<br />
    {<br />
        scanf("%d",&amp;x);<br />
        p = (Linklist *)malloc(sizeof(Linklist));<br />
        p -&gt; data = x;<br />
        p -&gt; next = NULL;<br />
        r-&gt;next = p;<br />
        r = r-&gt;next;    //指针r始终指向链表中末数据元素所在位置

    }<br />
    return L;<br />
}</pre>
</div>
<p>二、插入</p>
<div>
<pre class="prettyprint linenums">int InsItem1(Linklist *L,ElemType item,int x) /*给定的序号来插入*/<br />
{<br />
    int i = ;<br />
    Linklist *p,*t;<br />
    p = L;<br />
    t = (Linklist *)malloc(sizeof(Linklist));<br />
    t -&gt;data = item;<br />
    if(L-&gt;next==NULL)<br />
    {   /*若L为空表且要求将新结点插入到第0个位置*/<br />
        if(x==)<br />
            {<br />
                L-&gt;next=t;<br />
                t-&gt;next=NULL;<br />
                return ;<br />
            }<br />
        /*若L为空表且要求将新结点插入到第非0个位置     ，则操作失败*/<br />
        else<br />
        {<br />
            printf("wrong!\n");<br />
            return ;<br />
        }<br />
    }<br />
    while(p-&gt;next!=NULL&amp;&amp;i&lt;x)<br />
    /*查找第i个节点*/<br />
    {<br />
        p = p-&gt;next;<br />
        i++;<br />
    }<br />
    if(p-&gt;next==NULL&amp;&amp;i&lt;x)<br />
    /*在表中不存在插入位置i ，找不到，则插入操作失败*/<br />
    {<br />
        printf("The node %d is not exist\n",x);<br />
        return ;<br />
    }<br />
    else<br />
    {<br />
        t-&gt;next = p-&gt;next;<br />
        p-&gt;next = t;<br />
        return ;<br />
    }<br />
}

int InsItem2(Linklist *L,ElemType item,ElemType k) /*插入给定值在链表中的位置*/<br />
{<br />
    Linklist *q,*p,*t;<br />
    t = (Linklist *)malloc(sizeof(Linklist));<br />
    t-&gt;data = item;<br />
    if(L-&gt;next==NULL)<br />
    {<br />
        printf("The linklist is empty\n");<br />
        return ;<br />
    }<br />
    else<br />
    {<br />
        q = L;<br />
        p = L-&gt;next;<br />
        while(p-&gt;next!=NULL)/*查找值为k的结点*/<br />
        {<br />
            if(p-&gt;data!=k)<br />
            {<br />
                q = p;<br />
                p = p-&gt;next;<br />
            }<br />
            else<br />
                break;<br />
        }<br />
        if(p==NULL)/*如p= =NULL，则没有值为k的结点，插入操作失败*/<br />
        {<br />
            printf("The node %d is not exist\n",k);<br />
            return ;<br />
        }<br />
        else<br />
        {<br />
            q-&gt;next = t;<br />
            t-&gt;next = p;<br />
            return ;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>三、删除</p>
<div>
<pre class="prettyprint linenums">int DelItem(Linklist *L,int x)<br />
//在单链表中删除数据元素<br />
{<br />
    int i = ;<br />
    Linklist *p,*q;<br />
    p = L;<br />
    if(L-&gt;next==NULL) /*L为空表，无结点可删除*/<br />
    {<br />
        printf("The linklist is empty!\n");<br />
        return ;<br />
    }<br />
    while(p-&gt;next!=NULL&amp;&amp;i&lt;x)<br />
    {<br />
        p = p-&gt;next;<br />
        i++;<br />
    }<br />
    if(p-&gt;next==NULL)<br />
        /*若没有第i个结点，则删除操作失败*/<br />
    {<br />
        printf("The node %d is not exist\n",x);<br />
        return ;<br />
    }<br />
    else<br />
    {<br />
        q = p-&gt;next;<br />
        p-&gt;next = p-&gt;next-&gt;next;<br />
        free(q);<br />
        return ;<br />
    }

}</pre>
</div>
<p>四、查找</p>
<div>
<pre class="prettyprint linenums">int LocItem(Linklist *L,ElemType x)<br />
//查找给定值的结点位置<br />
{<br />
    Linklist *p,*q,*r;<br />
    int i = ;<br />
    if(L-&gt;next==NULL)<br />
    {<br />
        printf("The linklist is empty\n");<br />
        return ;<br />
    }<br />
    else<br />
    {<br />
        p = L-&gt;next;<br />
        while(p!=NULL)<br />
        {<br />
            if(p-&gt;data!=x)<br />
            {<br />
                i++;<br />
                p = p-&gt;next;<br />
            }<br />
            else<br />
                break;<br />
        }<br />
        if(p==NULL)<br />
        /*如p= =NULL，则没有值为item的结点，删除操作失败*/<br />
        {<br />
            printf("The node %d is not exist\n",x);<br />
            return ;<br />
        }<br />
        /*若找到该节点返回该节点的位置*/<br />
        else<br />
            return i;<br />
    }<br />
}</pre>
</div>
<p>五、输出</p>
<div>
<pre class="prettyprint linenums">void output(Linklist *L) //输出<br />
{<br />
    Linklist *p;<br />
    p = L-&gt;next;<br />
    printf("output element: \n");<br />
    for(;p!=NULL;p=p-&gt;next)<br />
    {<br />
        printf(" %d ",p-&gt;data);<br />
    }<br />
    printf("\n");<br />
}</pre>
</div>
<p>六、主函数部分</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    ElemType x = ;<br />
    Linklist *L;<br />
    L = CreateList(x);<br />
    output(L);<br />
    InsItem1(L,,);<br />
    output(L);<br />
    InsItem1(L,,);<br />
    output(L);<br />
    DelItem(L,);<br />
    output(L);<br />
    printf("3的位置是: %d",LocItem(L,));<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93xyvg9.html">React Native JSX value should be expression or a quoted JSX text&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390knn3q.html">制作Java视频播放器</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrvyvq.html">MAC OS X 常用通用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypk1gq.html">synchronized的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oko35e9.html">&lbrack;Stephen&rsqb;转载 如何提高测试用例评审效率</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1d319.html">Python基础篇-day7</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zok7j1q.html">util&colon;properties与context&colon;property-placeholder</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0ryl8.html">一次young gc耗时过长优化过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y737g8.html">一些重要 Docker 命令的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpn2gjq.html">Jenkins系统监测&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1e0exq.html">学习Makefile</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvdmoz8.html">【申嵌视频】5-1 ubuntu下安装VMWare Tools工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllkweq.html">CSS3圆角详解第一辑</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wpm2wq.html">Generative Adversarial Nets&lbrack;EBGAN&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5w1nrq.html">【原】继承AbstractRoutingDataSource再通过AOP实现动态数据源切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyl3vx9.html">【18】观察者模式（Observer Pattern）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw1dyv9.html">luogu P4178 Tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ovn5e8.html">CAD画图技巧经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k5nzwq.html">跟我学SharePoint 2013视频培训课程&mdash;&mdash; 版本控制以及内容审批&lpar;14&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96342139.html">JavaScript逻辑运算符</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zopy41q.html">【Python】excel读写操作 xlrd &amp;amp&semi; xlwt</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgp52m8.html">数据库 --&amp;gt&semi; MySQL使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey6mrm9.html">mysql的备份脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zv7z19.html">获取服务器时间js代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj6dv28.html">解决C盘中的文件不能修改问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd6mey9.html">Flash Builder4&period;7安装破解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1n4vxq.html">Kaggle竞赛 &mdash;&mdash; 房价预测 &lpar;House Prices&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp6vg39.html">Java暑假作业</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ko4jz9.html">vim配置之taglist插件安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z5dnn9.html">Linux系统安装gcc&sol;g&plus;&plus;详细过程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
